Botan: Botan::SHA_160_X86_32 Class Reference

Botan 1.10.17

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::SHA_160_X86_32 Class Reference

`#include <sha1_x86_32.h>`

Inheritance diagram for Botan::SHA_160_X86_32:

## Public Member Functions
void | clear ()
HashFunction * | clone () const
void | final (byte out[])
SecureVector< byte > | final ()
size_t | hash_block_size () const
std::string | name () const
size_t | output_length () const
SecureVector< byte > | process (const byte in[], size_t length)
SecureVector< byte > | process (const MemoryRegion< byte > &in)
SecureVector< byte > | process (const std::string &in)
| SHA_160_X86_32 ()
void | update (const byte in[], size_t length)
void | update (const MemoryRegion< byte > &in)
void | update (const std::string &str)
void | update (byte in)
template<typename T >
void | update_be (const T in)

## Protected Member Functions
void | add_data (const byte input[], size_t length)
void | copy_out (byte[])
void | final_result (byte output[])
virtual void | write_count (byte out[])

## Protected Attributes
SecureVector< u32bit > | digest
SecureVector< u32bit > | W

## Detailed Description

SHA-160 in x86 assembly

Definition at line 18 of file sha1_x86_32.h.

## Constructor & Destructor Documentation

## ◆ SHA_160_X86_32()

Botan::SHA_160_X86_32::SHA_160_X86_32 | ( |  | ) |
| inline

Definition at line 24 of file sha1_x86_32.h.

24 : SHA_160(81) {}
Botan::SHA_160::SHA_160
SHA_160()
Definition: sha160.h:27

## Member Function Documentation

## ◆ add_data()

void Botan::MDx_HashFunction::add_data | ( | const byte | input[],
|  | size_t | length
| ) |  |
| protectedvirtualinherited

Add more data to the computation

Parameters

  input | is an input buffer
  length | is the length of input in bytes

Implements Botan::Buffered_Computation.

Definition at line 41 of file mdx_hash.cpp.

References Botan::MDx_HashFunction::compress_n(), Botan::MemoryRegion< T >::copy(), and Botan::MemoryRegion< T >::size().

42 {
43 count += length;
44
45 if(position)
46 {
47 buffer.copy(position, input, length);
48
49 if(position + length >= buffer.size())
50 {
51 compress_n(&buffer[0], 1);
52 input += (buffer.size() - position);
53 length -= (buffer.size() - position);
54 position = 0;
55 }
56 }
57
58 const size_t full_blocks = length / buffer.size();
59 const size_t remaining = length % buffer.size();
60
61 if(full_blocks)
62 compress_n(input, full_blocks);
63
64 buffer.copy(position, input + full_blocks * buffer.size(), remaining);
65 position += remaining;
66 }
Botan::MDx_HashFunction::compress_n
virtual void compress_n(const byte blocks[], size_t block_n)=0
Botan::MemoryRegion::copy
void copy(const T in[], size_t n)
Definition: secmem.h:126
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ clear()

void Botan::SHA_160::clear | ( |  | ) |
| virtualinherited

Zeroize internal state

Reimplemented from Botan::MDx_HashFunction.

Definition at line 150 of file sha160.cpp.

References Botan::MDx_HashFunction::clear(), Botan::SHA_160::digest, Botan::SHA_160::W, and Botan::zeroise().

151 {
152 MDx_HashFunction::clear();
153 zeroise(W);
154 digest[0] = 0x67452301;
155 digest[1] = 0xEFCDAB89;
156 digest[2] = 0x98BADCFE;
157 digest[3] = 0x10325476;
158 digest[4] = 0xC3D2E1F0;
159 }
Botan::SHA_160::W
SecureVector< u32bit > W
Definition: sha160.h:55
Botan::SHA_160::digest
SecureVector< u32bit > digest
Definition: sha160.h:50
Botan::MDx_HashFunction::clear
void clear()
Definition: mdx_hash.cpp:32
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:428

## ◆ clone()

HashFunction* Botan::SHA_160_X86_32::clone | ( |  | ) | const
| inlinevirtual

Get a new object representing the same algorithm as *this

Reimplemented from Botan::SHA_160.

Definition at line 21 of file sha1_x86_32.h.

21 { return new SHA_160_X86_32; }
Botan::SHA_160_X86_32::SHA_160_X86_32
SHA_160_X86_32()
Definition: sha1_x86_32.h:24

## ◆ copy_out()

void Botan::SHA_160::copy_out | ( | byte | buffer[] | ) |
| protectedvirtualinherited

Copy the output to the buffer

Parameters

  buffer | to put the output into

Implements Botan::MDx_HashFunction.

Definition at line 141 of file sha160.cpp.

References Botan::SHA_160::digest, Botan::SHA_160::output_length(), and Botan::store_be().

142 {
143 for(size_t i = 0; i != output_length(); i += 4)
144 store_be(digest[i/4], output + i);
145 }
Botan::SHA_160::output_length
size_t output_length() const
Definition: sha160.h:22
Botan::SHA_160::digest
SecureVector< u32bit > digest
Definition: sha160.h:50
Botan::store_be
void store_be(u16bit in, byte out[2])
Definition: loadstor.h:412

## ◆ final() [1/2]

void Botan::Buffered_Computation::final | ( | byte | out[] | ) |
| inlineinherited

Complete the computation and retrieve the final result.

Parameters

  out | The byte array to be filled with the result. Must be of length output_length()

Definition at line 80 of file buf_comp.h.

Referenced by Botan::LubyRackoff::decrypt_n(), Botan::Lion::decrypt_n(), Botan::X942_PRF::derive(), Botan::KDF2::derive(), Botan::KDF1::derive(), Botan::PKCS5_PBKDF2::derive_key(), Botan::OpenPGP_S2K::derive_key(), Botan::PKCS5_PBKDF1::derive_key(), Botan::EMSA2::EMSA2(), Botan::LubyRackoff::encrypt_n(), Botan::Lion::encrypt_n(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::HandshakeHash::final(), Botan::HandshakeHash::final_ssl3(), Botan::Record_Reader::get_record(), Botan::MGF1::mask(), Botan::EMSA3::raw_data(), Botan::Randpool::reseed(), and Botan::HMAC_RNG::reseed().

80 { final_result(out); }

## ◆ final() [2/2]

SecureVector<byte> Botan::Buffered_Computation::final | ( |  | ) |
| inlineinherited

Complete the computation and retrieve the final result.

Returns
  SecureVector holding the result

Definition at line 87 of file buf_comp.h.

88 {
89 SecureVector<byte> output(output_length());
90 final_result(&output[0]);
91 return output;
92 }
Botan::Buffered_Computation::output_length
virtual size_t output_length() const =0

## ◆ final_result()

void Botan::MDx_HashFunction::final_result | ( | byte | out[] | ) |
| protectedvirtualinherited

Write the final output to out

Parameters

  out | is an output buffer of output_length()

Implements Botan::Buffered_Computation.

Definition at line 71 of file mdx_hash.cpp.

References Botan::MDx_HashFunction::clear(), Botan::MDx_HashFunction::compress_n(), Botan::MDx_HashFunction::copy_out(), Botan::MemoryRegion< T >::size(), Botan::MDx_HashFunction::write_count(), and Botan::zeroise().

72 {
73 buffer[position] = (BIG_BIT_ENDIAN ? 0x80 : 0x01);
74 for(size_t i = position+1; i != buffer.size(); ++i)
75 buffer[i] = 0;
76
77 if(position >= buffer.size() - COUNT_SIZE)
78 {
79 compress_n(&buffer[0], 1);
80 zeroise(buffer);
81 }
82
83 write_count(&buffer[buffer.size() - COUNT_SIZE]);
84
85 compress_n(&buffer[0], 1);
86 copy_out(output);
87 clear();
88 }
Botan::MDx_HashFunction::compress_n
virtual void compress_n(const byte blocks[], size_t block_n)=0
Botan::MDx_HashFunction::write_count
virtual void write_count(byte out[])
Definition: mdx_hash.cpp:93
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::MDx_HashFunction::clear
void clear()
Definition: mdx_hash.cpp:32
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:428
Botan::MDx_HashFunction::copy_out
virtual void copy_out(byte buffer[])=0

## ◆ hash_block_size()

size_t Botan::MDx_HashFunction::hash_block_size | ( |  | ) | const
| inlinevirtualinherited

The hash block size as defined for this algorithm

Reimplemented from Botan::HashFunction.

Definition at line 32 of file mdx_hash.h.

Referenced by Botan::MD4::compress_n(), Botan::MD5::compress_n(), Botan::SHA_160::compress_n(), and Botan::MDx_HashFunction::write_count().

32 { return buffer.size(); }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ name()

std::string Botan::SHA_160::name | ( |  | ) | const
| inlinevirtualinherited

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 21 of file sha160.h.

21 { return "SHA-160"; }

## ◆ output_length()

size_t Botan::SHA_160::output_length | ( |  | ) | const
| inlinevirtualinherited

Returns
  length of the output of this function in bytes

Implements Botan::Buffered_Computation.

Definition at line 22 of file sha160.h.

Referenced by Botan::SHA_160::copy_out().

22 { return 20; }

## ◆ process() [1/3]

SecureVector<byte> Botan::Buffered_Computation::process | ( | const byte | in[],
|  | size_t | length
| ) |  |
| inlineinherited

Update and finalize computation. Does the same as calling update() and final() consecutively.

Parameters

  in | the input to process as a byte array
  length | the length of the byte array

Returns
  the result of the call to final()

Definition at line 101 of file buf_comp.h.

Referenced by Botan::Randpool::add_entropy(), Botan::EME1::EME1(), and Botan::Cert_Extension::Subject_Key_ID::Subject_Key_ID().

102 {
103 add_data(in, length);
104 return final();
105 }

## ◆ process() [2/3]

SecureVector<byte> Botan::Buffered_Computation::process | ( | const MemoryRegion< byte > & | in | ) |
| inlineinherited

Update and finalize computation. Does the same as calling update() and final() consecutively.

Parameters

  in | the input to process

Returns
  the result of the call to final()

Definition at line 113 of file buf_comp.h.

References Botan::MemoryRegion< T >::size().

114 {
115 add_data(&in[0], in.size());
116 return final();
117 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ process() [3/3]

SecureVector<byte> Botan::Buffered_Computation::process | ( | const std::string & | in | ) |
| inlineinherited

Update and finalize computation. Does the same as calling update() and final() consecutively.

Parameters

  in | the input to process as a string

Returns
  the result of the call to final()

Definition at line 125 of file buf_comp.h.

126 {
127 update(in);
128 return final();
129 }
Botan::Buffered_Computation::update
void update(const byte in[], size_t length)
Definition: buf_comp.h:33

## ◆ update() [1/4]

void Botan::Buffered_Computation::update | ( | const byte | in[],
|  | size_t | length
| ) |  |
| inlineinherited

Add new input to process.

Parameters

  in | the input to process as a byte array
  length | of param in in bytes

Definition at line 33 of file buf_comp.h.

Referenced by Botan::HMAC_RNG::add_entropy(), Botan::Comb4P::clear(), Botan::LubyRackoff::decrypt_n(), Botan::Lion::decrypt_n(), Botan::X942_PRF::derive(), Botan::KDF2::derive(), Botan::KDF1::derive(), Botan::PKCS5_PBKDF2::derive_key(), Botan::OpenPGP_S2K::derive_key(), Botan::PKCS5_PBKDF1::derive_key(), Botan::LubyRackoff::encrypt_n(), Botan::Lion::encrypt_n(), Botan::HandshakeHash::final(), Botan::HandshakeHash::final_ssl3(), Botan::Record_Reader::get_record(), Botan::MGF1::mask(), Botan::HMAC_RNG::reseed(), Botan::EAX_Base::start_msg(), and Botan::EMSA3::update().

33 { add_data(in, length); }

## ◆ update() [2/4]

void Botan::Buffered_Computation::update | ( | const MemoryRegion< byte > & | in | ) |
| inlineinherited

Add new input to process.

Parameters

  in | the input to process as a MemoryRegion

Definition at line 39 of file buf_comp.h.

References Botan::MemoryRegion< T >::size().

40 {
41 add_data(&in[0], in.size());
42 }
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ update() [3/4]

void Botan::Buffered_Computation::update | ( | const std::string & | str | ) |
| inlineinherited

Add new input to process.

Parameters

  str | the input to process as a std::string. Will be interpreted as a byte array based on the strings encoding.

Definition at line 63 of file buf_comp.h.

64 {
65 add_data(reinterpret_cast<const byte*>(str.data()), str.size());
66 }

## ◆ update() [4/4]

void Botan::Buffered_Computation::update | ( | byte | in | ) |
| inlineinherited

Process a single byte.

Parameters

  in | the byte to process

Definition at line 72 of file buf_comp.h.

72 { add_data(&in, 1); }

## ◆ update_be()

template<typename T >

void Botan::Buffered_Computation::update_be | ( | const T | in | ) |
| inlineinherited

Add an integer in big-endian order

Parameters

  in | the value

Definition at line 48 of file buf_comp.h.

References Botan::get_byte().

Referenced by Botan::KDF2::derive(), Botan::PKCS5_PBKDF2::derive_key(), Botan::Record_Reader::get_record(), and Botan::MGF1::mask().

49 {
50 for(size_t i = 0; i != sizeof(T); ++i)
51 {
52 byte b = get_byte(i, in);
53 add_data(&b, 1);
54 }
55 }
Botan::get_byte
byte get_byte(size_t byte_num, T input)
Definition: get_byte.h:21
Botan::byte
unsigned char byte
Definition: types.h:22

## ◆ write_count()

void Botan::MDx_HashFunction::write_count | ( | byte | out[] | ) |
| protectedvirtualinherited

Write the count, if used, to this spot

Parameters

  out | where to write the counter to

Definition at line 93 of file mdx_hash.cpp.

References Botan::MDx_HashFunction::hash_block_size(), Botan::Buffered_Computation::output_length(), Botan::store_be(), and Botan::store_le().

Referenced by Botan::MDx_HashFunction::final_result().

94 {
95 if(COUNT_SIZE < 8)
96 throw Invalid_State("MDx_HashFunction::write_count: COUNT_SIZE < 8");
97 if(COUNT_SIZE >= output_length() || COUNT_SIZE >= hash_block_size())
98 throw Invalid_Argument("MDx_HashFunction: COUNT_SIZE is too big");
99
100 const u64bit bit_count = count * 8;
101
102 if(BIG_BYTE_ENDIAN)
103 store_be(bit_count, out + COUNT_SIZE - 8);
104 else
105 store_le(bit_count, out + COUNT_SIZE - 8);
106 }
Botan::store_le
void store_le(u16bit in, byte out[2])
Definition: loadstor.h:427
Botan::Invalid_Argument
std::invalid_argument Invalid_Argument
Definition: exceptn.h:20
Botan::u64bit
unsigned long long u64bit
Definition: types.h:49
Botan::store_be
void store_be(u16bit in, byte out[2])
Definition: loadstor.h:412
Botan::MDx_HashFunction::hash_block_size
size_t hash_block_size() const
Definition: mdx_hash.h:32
Botan::Buffered_Computation::output_length
virtual size_t output_length() const =0

## Member Data Documentation

## ◆ digest

SecureVector<u32bit> Botan::SHA_160::digest
| protectedinherited

The digest value, exposed for use by subclasses (asm, SSE2)

Definition at line 50 of file sha160.h.

Referenced by Botan::SHA_160::clear(), Botan::SHA_160::compress_n(), and Botan::SHA_160::copy_out().

## ◆ W

SecureVector<u32bit> Botan::SHA_160::W
| protectedinherited

The message buffer, exposed for use by subclasses (asm, SSE2)

Definition at line 55 of file sha160.h.

Referenced by Botan::SHA_160::clear(), and Botan::SHA_160::compress_n().

The documentation for this class was generated from the following files:

- src/hash/sha1_x86_32/sha1_x86_32.h
- src/hash/sha1_x86_32/sha1_x86_32.cpp